=== modified file '__init__.py'
--- __init__.py	2009-05-27 07:23:03 +0000
+++ __init__.py	2009-06-03 03:30:38 +0000
@@ -70,7 +70,9 @@
             host = DEFAULT_HOST
         if port is None:
             port = DEFAULT_PORT
-        argv = ['--host', host, '--port', str(port), transport.base]
+        allow_writes = not transport.is_readonly()
+        argv = ['--host', host, '--port', str(port),
+            '--allow-writes', allow_writes, transport.base]
         config = LoggerheadConfig(argv)
         app = BranchesFromTransportRoot(transport, config)
         app = HTTPExceptionHandler(app)
@@ -94,6 +96,7 @@
             def run(self, *args, **kw):
                 if 'http' in kw:
                     from bzrlib.transport import get_transport
+                    allow_writes = kw.get('allow_writes', False)
                     path = kw.get('directory', '.')
                     port = kw.get('port', DEFAULT_PORT)
                     # port might be an int already...
@@ -101,7 +104,10 @@
                         host, port = port.split(':')
                     else:
                         host = DEFAULT_HOST
-                    transport = get_transport(path)
+                    if allow_writes:
+                        transport = get_transport(path)
+                    else:
+                        transport = get_transport('readonly+' + path)
                     serve_http(transport, host, port)
                 else:
                     super(cmd_serve, self).run(*args, **kw)

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2009-06-02 13:26:49 +0000
+++ loggerhead/config.py	2009-06-03 03:30:38 +0000
@@ -20,6 +20,7 @@
         log_folder=None,
         use_cdn=False,
         sql_dir=None,
+        allow_writes=False,
         )
     parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
                       help="Serve user directories as ~user.")
@@ -49,6 +50,8 @@
                       help="Serve YUI from Yahoo!'s CDN")
     parser.add_option('--cache-dir', dest='sql_dir',
                       help="The directory to place the SQL cache in")
+    parser.add_option('--allow-writes', action='store_true',
+                      help="Allow writing to the Bazaar server.")
     return parser
 
 

=== modified file 'serve-branches'
--- serve-branches	2009-05-04 20:21:08 +0000
+++ serve-branches	2009-06-03 03:30:38 +0000
@@ -51,7 +51,10 @@
 
     load_plugins()
 
-    transport = get_transport(path)
+    if config.get_option('allow_writes'):
+        transport = get_transport(path)
+    else:
+        transport = get_transport('readonly+' + path)
 
     if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
         print "--trunk-dir is only valid with --user-dirs"

